using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Controls;
using GrapeCity.ActiveReports.SectionReportModel;
using GrapeCity.ActiveReports.Document.Section;
using GrapeCity.ActiveReports.Document;
using GrapeCity.ActiveReports.Chart;

namespace PieChart_Color
{
    /// <summary>
    /// Summary description for NewActiveReport1.
    /// </summary>
    public partial class NewActiveReport1 : GrapeCity.ActiveReports.SectionReport
    {

        public NewActiveReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        private void detail_Format(object sender, EventArgs e)
        {
            this.chartControl1.Legends[0].Alignment = GrapeCity.ActiveReports.Chart.Alignment.Bottom;
            Series s = new Series();
            this.chartControl1.Series.Add(s);
            s.Type = ChartType.Doughnut3D;
            s.ValueMemberX = "ProductName";
            // Value to X axis
            s.ValueMembersY = "UnitsInStock";
            // Value to Y axis
            s.Marker = new Marker(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Graphics);
            s.ChartArea = this.chartControl1.ChartAreas[0];

            int i = 0;
            int colorCount = 0;
            double seriesTotal = 0.0;

            for (i = 0; i <= s.Points.Count - 1; i++)
            {
                BackdropItem bd = default(BackdropItem);
                switch (colorCount)
                {
                    case 0:
                        bd = new BackdropItem(System.Drawing.Color.Blue);
                        break;
                    case 1:
                        bd = new BackdropItem(System.Drawing.Color.Yellow);
                        break;
                    case 2:
                        bd = new BackdropItem(System.Drawing.Color.Violet);
                        break;
                    case 3:
                        bd = new BackdropItem(System.Drawing.Color.Red);
                        break;
                    case 4:
                        bd = new BackdropItem(System.Drawing.Color.Black);
                        break;
                    case 5:
                        bd = new BackdropItem(System.Drawing.Color.Pink);
                        break;
                    case 6:
                        bd = new BackdropItem(System.Drawing.Color.Purple);
                        break;
                    case 7:
                        bd = new BackdropItem(System.Drawing.Color.Gray);
                        break;
                    case 8:
                        bd = new BackdropItem(System.Drawing.Color.Green);
                        break;
                    case 9:
                        bd = new BackdropItem(System.Drawing.Color.White);
                        break;
                    case 10:
                        bd = new BackdropItem(System.Drawing.Color.Orange);
                        break;
                }

                colorCount = colorCount + 1;
                s.Points[i].Properties["Backdrop"] = bd;
                seriesTotal = seriesTotal + s.Points[i].YValues[0];
                s.Points[i].LegendText = s.Points[i].XValue.ToString();
            }

            System.Drawing.Font markerFont = new Font("Arial", 7);

            for (i = 0; i <= s.Points.Count - 1; i++)
            {
                Marker m = new Marker(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Graphics);
                m.Label = new LabelInfo(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Auto);
                m.Label.Font = new GrapeCity.ActiveReports.Chart.FontInfo(System.Drawing.Color.Black, markerFont, 0);
                m.Label.Format = s.Points[i].XValue.ToString() + ", " + (s.Points[i].YValues[0] / seriesTotal).ToString("#,###.##%");
                s.Points[i].Marker = m;
            }
        }

        private void NewActiveReport1_ReportStart(object sender, EventArgs e)
        {
            GrapeCity.ActiveReports.Data.OleDBDataSource ds = new GrapeCity.ActiveReports.Data.OleDBDataSource();
            ds.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Program Files\\GrapeCity\\ActiveReports 6\\Data\\NWIND.mdb;Persist Security Info=False";
            ds.SQL = "Select * from products where unitprice < 10";
            ds.CommandTimeout = 30;
            this.chartControl1.DataSource = ds;
        }
    }
}
